      SUBROUTINE CALC3Z
C
C         TIME SMOOTHER FOR FIRST ITERATION
C
      USE swim_arrays
C
      implicit none
C
      include "mpif.h"
      include "swim.h"
C
      integer i,j
      integer js,je,taskid,numtasks,req,istat,ierr
      integer M,N,MP1,NP1
      real TDT,EL,PI,TPI,DI,DJ,PCF
C
      COMMON/decomp/js,je,taskid,numtasks,req(MAX_REQ),
     1                            istat(MPI_STATUS_SIZE,MAX_REQ)
C
      COMMON /CONS/ TDT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
CME -----------------------------------------

      TDT = TDT+TDT
      DO 400 J=js,je
      DO 400 I=1,MP1
      UOLD(I,J) = U(I,J)
      VOLD(I,J) = V(I,J)
      POLD(I,J) = P(I,J)
      U(I,J)    = UNEW(I,J)
      V(I,J)    = VNEW(I,J)
      P(I,J)    = PNEW(I,J)
      if(j.eq.n)then
      UOLD(I,J+1) = U(I,J+1)
      VOLD(I,J+1) = V(I,J+1)
      POLD(I,J+1) = P(I,J+1)
      U(I,J+1)    = UNEW(I,J+1)
      V(I,J+1)    = VNEW(I,J+1)
      P(I,J+1)    = PNEW(I,J+1)
      endif
  400 CONTINUE
      RETURN
      END
CME ----------------------------------------
C SPEC removed CCMIC$ MICRO
      SUBROUTINE CALC3
C
C         TIME SMOOTHER
C
      USE swim_arrays
C
      implicit none
C
      include "mpif.h"
      include "swim.h"
C
      integer i,j
      integer js,je,taskid,numtasks,req,istat,ierr
      integer M,N,MP1,NP1
      real TDT,EL,PI,TPI,DI,DJ,PCF
C
      COMMON/decomp/js,je,taskid,numtasks,req(MAX_REQ),
     1                            istat(MPI_STATUS_SIZE,MAX_REQ)
C
      COMMON /CONS/ TDT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF

C
C        TIME SMOOTHING AND UPDATE FOR NEXT CYCLE
C

C SPEC removed CCMIC$ DO GLOBAL

C$OMP PARALLELDO
C$OMP&SHARED (M,N,U,V,P,UNEW,VNEW,PNEW,UOLD,VOLD,POLD)
C$OMP&SHARED (JS,JE)
C$OMP&PRIVATE (I,J)
      DO 300 J=js,je
        DO 300 I=1,M
          UOLD(I,J) = U(I,J)+ALPHA*(UNEW(I,J)-2.*U(I,J)+UOLD(I,J))
          VOLD(I,J) = V(I,J)+ALPHA*(VNEW(I,J)-2.*V(I,J)+VOLD(I,J))
          POLD(I,J) = P(I,J)+ALPHA*(PNEW(I,J)-2.*P(I,J)+POLD(I,J))
          U(I,J) = UNEW(I,J)
          V(I,J) = VNEW(I,J)
          P(I,J) = PNEW(I,J)
  300 CONTINUE
CME-------------------------------------------

C
C     PERIODIC CONTINUATION
C
CME----------------------------------------------
C
      DO 320 J=1,N
        UOLD(M+1,J) = UOLD(1,J)
        VOLD(M+1,J) = VOLD(1,J)
        POLD(M+1,J) = POLD(1,J)
        U(M+1,J) = U(1,J)
        V(M+1,J) = V(1,J)
        P(M+1,J) = P(1,J)
  320 CONTINUE
C
CME------------------------------------------------------
      if(taskid.eq.numtasks-1)then                        
      cALL mpi_irecv(v(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(u(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      cALL mpi_irecv(p(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      cALL mpi_irecv(vold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      cALL mpi_irecv(uold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      cALL mpi_irecv(pold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(v(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      cALL mpi_isend(u(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      cALL mpi_isend(p(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      cALL mpi_isend(vold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      cALL mpi_isend(uold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      cALL mpi_isend(pold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif 
      cALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(12,req,istat,ierr)
      endif

c      DO 325 I=1,M
c      UOLD(I,N+1) = UOLD(I,1)
c      VOLD(I,N+1) = VOLD(I,1)
c      POLD(I,N+1) = POLD(I,1)
c      U(I,N+1)    = U(I,1)
c      V(I,N+1)    = V(I,1)
c      P(I,N+1)    = P(I,1)
c 325 CONTINUE

      if(taskid.eq.numtasks-1)then                        
      cALL mpi_irecv(v(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(u(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      cALL mpi_irecv(p(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      cALL mpi_irecv(vold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      cALL mpi_irecv(uold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      cALL mpi_irecv(pold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(v(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      cALL mpi_isend(u(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      cALL mpi_isend(p(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      cALL mpi_isend(vold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      cALL mpi_isend(uold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      cALL mpi_isend(pold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif
      cALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(12,req,istat,ierr)
      endif

CME
CME      UOLD(M+1,N+1) = UOLD(1,1)
CME      VOLD(M+1,N+1) = VOLD(1,1)
CME      POLD(M+1,N+1) = POLD(1,1)
CME      U(M+1,N+1) = U(1,1)
CME      V(M+1,N+1) = V(1,1)
CME      P(M+1,N+1) = P(1,1)

C
      RETURN
      END
